/* genfnum128.c  2006-jun-30 */
/* 16-bit fnumber generator  */
/* NON COMMERCIAL USE ONLY   */

#include <stdio.h>
#include <math.h>

#define ITEMPERLINE 8
#define STEPS 128
#define TABSIZE (12*STEPS)

const char tonename[12][3] = {
  "C ", "C#", "D ", "D#", "E ", "F ",
  "F#", "G ", "G#", "A ", "A#", "B "
}; // const char tonename[][]

int main()
{
  int i, j, hex;
  double Hz, fnum;

  printf("\r\xa/* 16-bit precision f-number table */\r\xa");
  printf(  "/* %d steps per semitone          */\r\xa", STEPS);
  printf(  "/* 100/%d = %7.5f cent step     */\r\xa\r\xa", 
          STEPS,100.0/STEPS);
  printf("#include \"tonegen.h\"\r\xa\r\xa");
  printf("const uint16_t fnum%d[%d] = {", STEPS, TABSIZE);
  for (i = 0; i < 12; i++) {
    if (0 != i) printf(",");
    printf("\r\xa/***  %s  ***/", tonename[i]);
    for (j = 0; j < 128; j++) {
    Hz = pow(2.0, (i + j/128.0)/12.0);
    fnum = 0x8000 * Hz;
    hex = round(fnum);
    if (0 == (j % ITEMPERLINE)) {
      if (0 != j) printf(",");
      printf("\r\xa  ");
    }
    else printf(",");
    printf(" 0x%.4x", hex);
    } // for (j = ...
  } // for (i = ...
  printf("\r\xa}; /* const uint16_t fnum%d[%d] */\r\xa",
         STEPS, TABSIZE);
  return(0);
} // int main()
