/* gen_stab4k.c                                    */
/* generate 4K sine table of total 16K, 2006-02-18 */
/* NON COMMERCIAL USE ONLY                         */

#include <stdio.h>
#include <math.h>

#define ITEM_PER_LINE 8
#define NPERIOD 16384
#define TSIZE 4097
#define STSIZE 256
#define PEAK  32767.0

int main()
{
  int i, j;
  double s, c;
  short int si;
  printf("// %d point sine table\r\xa", NPERIOD);
  printf("// only first %d points (0..pi/2) for symmetry\r\xa\r\xa", TSIZE); 
  printf("#include \"tonegen.h\"\r\xa\r\xa");
  printf("#if (%d == STAB_SIZE)\r\xa", TSIZE);
  printf("const int16_t stab[%d] = {", TSIZE);
  for (i = 0; i < TSIZE; i++) {
    s = sin(2 * M_PI * i / NPERIOD);
    si = round(PEAK * s);
    if (0 == (i % ITEM_PER_LINE)) printf("\r\xa    ");
    printf("0x%.4x", 0xffff & si);
    printf("%s", (i != (TSIZE-1) ? ", " : ""));
  }
  printf("\r\xa}; // const int16_t stab[]\r\xa");
/*
  printf("// sub table for %d point table\r\xa", NPERIOD);
  printf("const int16_t sstab[%d] = {", STSIZE);
  for (i = 0; i < STSIZE; i++) {
    j = ((0xfc & i) << 8) + (0x03 & i);
    c = cos(2 * M_PI * j / (4*NPERIOD));
    s =  c * sin(2*M_PI*(0x03 & i) / (4*NPERIOD));
    si = (PEAK * s);
    if (0 == (i % ITEM_PER_LINE)) printf("\r\xa    ");
    printf("0x%.4x", 0xffff & si);
    printf("%s", (i != (STSIZE-1) ? ", " : ""));
  }
  printf("\r\xa}; // const int16_t sstab[]\r\xa");
*/
  printf("#endif\r\xa");
  return(0);
}
