/****************************************************************/
/*                                                              */
/*  sw_input.c : Input routine for Push switch / Rotary encoder */
/*                                                              */
/*  NON COMMERCIAL USE ONLY                                     */
/*                                                              */
/*  2007/03/26 Rev. 1.00 by pcm1723                             */
/*                                                              */
/****************************************************************/

#include "tonegen.h"

int8_t sw_input(void)
{
  int8_t sw_rel = 0; // assume no input
#ifndef STM32F103
  int8_t shift = (0 == GET_SFT_KEY);
  int8_t curr_re;
  curr_re = SW_RE_BITMASK & sw_bits; // get current rotary encoder 
  if (SW_RE_DETENT == curr_re) { // now on the detent
    switch((int8_t)(SW_RE_BITMASK & re_state)) {
      case SW_RE_FWD :
        sw_rel = (((SW_RL_TH <= inc_sw_rl) ^ shift) ? PRESS : CLICK);
        break;
      case SW_RE_BACK :
        sw_rel = (((SW_RL_TH <= dec_sw_rl) ^ shift) ? -PRESS : -CLICK);
        break;
      default: break;
    } // switch
  } // if ()
  re_state = curr_re;
  if (0 == (SW_INC_BIT & sw_bits)) inc_sw_rl++;
  else                             inc_sw_rl = 0;
  if (0 == (SW_DEC_BIT & sw_bits)) dec_sw_rl++;
  else                             dec_sw_rl = 0;
#endif
  return (sw_rel);
} // int8_t sw_input()
