/**********************************************/
/* unit (sound generation entity, 2-operator) */
/*                                            */
/* NON COMMERCIAL USE ONLY                    */
/*                                            */
/* 2007/03/26 Rev. 1.00 by pcm1723            */
/*                                            */
/**********************************************/

#include "tonegen.h"

int16_t unit(unit_prop_t *u_p)
{
  int16_t w0, w1;
  op_prop_t *o_p = &(u_p->op_prop[0]);

  if (OFF == o_p[1].egmode) {
    o_p->phacc = 0;
    o_p[1].phacc = 0;
    o_p->opout = 0;
  }

  if (u_p->uv.fb) w1 = o_p->opout; // feedback = 1..7
  else            w1 = 0;                     // feedback = 0
  o_p->mod_in = (int32_t)w1 << (8+(u_p->uv.fb)); // feedback input 
  w0 = (*o_p->vp.op_func_p)(o_p); // OP0 mod/carr
//  o_p->opout = w0; // remember current OP0 output for next feedback
  o_p++;  // advance operator property pointer to OP1
  if (1 == u_p->uv.alg) { // ALG == 1, parallel   +--------+ 
    o_p->mod_in = 0;                      //      +->[OP0]-+->+
    w1 = (*o_p->vp.op_func_p)(o_p);       //                  |  
    return(w0 + w1);                      //    0 -->[OP1]----+--------->
  } else { // ALG == 0, series            //
//    op_prop_t *o_p = &(u_p->op_prop[1]);  //      +--------+
    o_p->mod_in = ((int32_t)w0 << 17);    //      |        |
//    o_p->mod_in = 0;
    w1 = (*o_p->vp.op_func_p)(o_p);       //      +->[OP0]-+--->[OP1]--->  
    return(w1);
  }  
} // int16_t unit() 

/*
int unit(unit_prop_t *u_p)
{
  short w0, w1;
  if (u_p->fb) w1 = u_p->op_prop[0].opout; // feedback = 1..7
  else         w1 = 0;                     // feedback = 0
  u_p->op_prop[0].mod_in = (long int)w1 << (8+(u_p->fb)); // feedback input 
  w0 = (*u_p->op_prop[0].op_func_p)(&(u_p->op_prop[0])); // OP0 mod/carr
  if (1 == u_p->alg) { // ALG == 1, parallel      +--------+ 
    op_prop_t *o_p = &(u_p->op_prop[1]);  //      |        |
    o_p->mod_in = 0;                      //      +->[OP0]-+->+
    w1 = (*o_p->op_func_p)(o_p);          //                  |  
    return(w0 + w1);                      //    0 -->[OP1]----+--------->
  } else { // ALG == 0, series            //
    op_prop_t *o_p = &(u_p->op_prop[1]);  //      +--------+
    o_p->mod_in = (w0 << 17);             //      |        |
    w1 = (*o_p->op_func_p)(o_p);          //      +->[OP0]-+--->[OP1]--->  
    return(w1);
  }  
} // int unit() 
*/
